
# Copyright (C) Johan Ceuppens 2010 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *

class Arrow(Gameobject):
    "Box"
    def __init__(self, xx,yy,ox,oy,player):
        Gameobject.__init__(self,xx,yy)
        self.ox = ox
        self.oy = oy
        self.hitpoints = 1000000000 #FIX else wall/floor disappears
        #FIX is in base class self.image = pygame.image.load('./pics/.bmp').convert()
        #self.image.set_colorkey((0,0,0)) 
        self.image = pygame.image.load('./pics/arrow1-16x16.bmp').convert()
        self.image.set_colorkey((0,0,255)) 
        self.image2 = pygame.image.load('./pics/arrowleft1-16x16.bmp').convert()
        self.image2.set_colorkey((0,0,255)) 

	self.player = player


    def draw(self, screen, room):
        if self.player.x+room.relativex < self.ox:
		screen.blit(self.image,(self.x-room.relativex,self.y-room.relativey))
        else:
		screen.blit(self.image2,(self.x-room.relativex,self.y-room.relativey))

    def update(self,room,player):
	if player.x+room.relativex < self.ox:
		self.x += 15
	elif player.x+room.relativex > self.ox:
		self.x -= 15
		
	if abs(self.x-self.ox) < 20:
		room.removeobject(self)
