
# Copyright (C) Johan Ceuppens 2010 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from rng import *
from intelligence import *
from communicate import *
from magic import *
from luck import *
from stealth import *

class GameobjectMagicUser:
    "Game object"
    def __init__(self, rng, magic, spellkeys, spelldictionary):
	self.rng = rng
	self.intelligence = Intelligence(self.rng.rolld10() + 10)
	self.communicate = Communicate(self.rng.rolld10() + 10)
	self.magic = Magic(magic)
	self.luck = Luck(self.rng.rolld100()+100)
	self.stealth = Stealth(self.rng.rolld100()+100) 
	self.magicuserlevel = self.rng.rolld10()
	self.spelldictionary = spelldictionary
	self.spells = dict()

	for k in spellkeys:
		if k:
			self.spells[k] = spelldictionary.dict[k] 
				
		

    def cast(self, room, player):
	if self.magic.get() <= 0:
		return -1
	
	castp = self.rng.rolld6()

	if castp == 1:
		spellchoice = self.rng.rollbetween(0, len(self.spells.keys()))
		i = 0
		for k in self.spells.keys():
			if i == spellchoice:
				print "enemy casts!"
				self.spells[k]()
				break	
			i += 1	
			
