
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *
from stateimagelibrary import *
import random
from time import *
from rng import *
from strength import *
from dexterity import *

class KnightFighting(Gameobject):
    "Enemy Knight"
    def __init__(self,xx,yy):
	Gameobject.__init__(self, xx, yy)
        self.w = 48
        self.h = 64

        self.hitpoints = 14
	self.strength = Strength(13)
	self.dexterity = Dexterity(13)

        self.swordimage = pygame.image.load('./pics/sword1-36x36.bmp').convert()
        self.swordimage.set_colorkey((0,0,255)) 
	
        self.swordimage2 = pygame.image.load('./pics/swordleft1-36x36.bmp').convert()
        self.swordimage2.set_colorkey((0,0,255)) 
	
	self.stimlibleft = Stateimagelibrary()	
	self.stimlibright = Stateimagelibrary()	
        image = pygame.image.load('./pics/knightfightingleft1-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft1-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft1-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft1-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft1-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
        image = pygame.image.load('./pics/knightfightingleft2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft3-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft3-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft3-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft3-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft3-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
        image = pygame.image.load('./pics/knightfightingleft4-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft4-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft4-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft4-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft4-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
        image = pygame.image.load('./pics/knightfightingleft3-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft3-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft3-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft3-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft3-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
        image = pygame.image.load('./pics/knightfightingleft2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)



	
	image = pygame.image.load('./pics/knightfightingright1-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright1-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright1-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright1-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright1-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
        image = pygame.image.load('./pics/knightfightingright2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
        image = pygame.image.load('./pics/knightfightingright3-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright3-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright3-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright3-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright3-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
        image = pygame.image.load('./pics/knightfightingright4-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright4-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright4-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright4-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright4-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
        image = pygame.image.load('./pics/knightfightingright3-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright3-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright3-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright3-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright3-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
        image = pygame.image.load('./pics/knightfightingright2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/knightfightingright2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)

	
        self.stimlibleftfight = Stateimagelibrary()	
	self.stimlibrightfight = Stateimagelibrary()	
	image = pygame.image.load('./pics/knightfightingright1-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibrightfight.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft1-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleftfight.addpicture(image)

	self.stimlibleftfightlow = Stateimagelibrary()	
	self.stimlibrightfightlow = Stateimagelibrary()	
	image = pygame.image.load('./pics/knightfightingright2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibrightfightlow.addpicture(image)
	image = pygame.image.load('./pics/knightfightingleft2-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleftfightlow.addpicture(image)

        self.battlemode = 1

	self.direction = "left"
        self.prevdirection = "left"

        self.CLOSEUPW = 58
        self.counter = 0

    def draw(self, screen, room):
        #FIXME - or + room.relativex
	if (self.direction == "left"):
            self.stimlibleft.draw(screen, self.x+room.relativex,self.y+room.relativey)
	elif (self.direction == "right"):
            self.stimlibright.draw(screen, self.x+room.relativex,self.y+room.relativey)

        elif self.direction == "stop":
            if self.player.x-room.relativex < self.x:
                self.stimlibleftfight.drawstatic(screen, self.x+room.relativex,self.y+room.relativey,0)
                screen.blit(self.swordimage2,(self.x+room.relativex-self.w+5,self.y+room.relativey))
            if self.player.x-room.relativex > self.x:
                self.stimlibrightfight.drawstatic(screen, self.x+room.relativex,self.y+room.relativey,0)
                screen.blit(self.swordimage,(self.x+room.relativex+self.w+5,self.y+room.relativey))
            
    def update(self,room,player):
        self.player = player
        # combat for knight i.e. move in and fight like a knight
        if player.x-room.relativex < self.x:
            self.direction = "left"
            self.prevdirection = "left"
        elif player.x-room.relativex > self.x:
            self.direction = "right"
            self.prevdirection = "right"

        if abs(player.x-room.relativex - self.x) < self.CLOSEUPW:
            if self.direction != "stop":
                self.direction = "stop"
            elif self.direction == "stop" and self.counter <= 0:
                r = randint(1,2)
                if r == 1:
                    self.direction = "left"
                else:
                    self.direction = "right"

##	if (not self.collideobjectX(room)): 
##	    if (self.direction == "left"):
##	        self.x +=2
##	        self.direction = "right" 
##	    elif (self.direction == "right"):
##	        self.x -=2
##	        self.direction = "left"
##	        
        if (self.direction == "stop"):
            #FIXME          
            #self.fight(room,player,0)
            if randint(0,10) == 0:
                player.hitwithenemyweapon(self.getrng().rollknight())
                self.counter = 10

	if (self.direction == "left"):
	        self.x -=1 
	elif (self.direction == "right"):
	        self.x +=1

    def collide(self, room, player):        
	if (player.x > self.x-room.relativex-self.w  and 
	player.x < self.x-room.relativex+self.w+self.w and 
	player.y > self.y-room.relativey-self.h and 
	player.y < self.y-room.relativey + self.h +self.h):
	    print "collision with Knight!"
	    if player.hit():
		return 1 
	    else:
	    	return 2 
	else:
	    return 0

		 
    def collidewithsword(self, room, player):
        print 'knight x=%d y=%d player x=%d y=%d' % (self.x,self.y,player.x-room.relativex,player.y-room.relativey)
	if (player.x-room.relativex > self.x  and 
	player.x-room.relativex < self.x+self.w and 
	player.y-room.relativey > self.y and 
	player.y-room.relativey < self.y + self.h):
	    print "collision with Sword knight!"
	    return 1 
	else:
	    return 0


    def fight(self,room,player):
        self.fightcounter = 1
        # FIXME FIGHT!
        
        o = player.collidewithenemyweapon(room,self)
        
        if o:
            # FIXME roll
            player.hitwithenemyweapon(self.getrng().rollknight())
