
# Copyright (C) Johan Ceuppens 2010 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *
from random import *

from deitybase import *

class ArcanaDomain(Domain):
    "Spell or Priest domain base class for Magic domain"
    def __init__(self,deity):
	Domain.__init__(self,deity)

    def level1(self,player):
	# Nystul's undetectable aura 
	return self.deity.rolld2() 

    def level2(self,player):
	# Identify
	return self.deity.rolld2() 

    def level3(self,player):
	# Dispel magic
	return self.deity.rolld2() 

    def level4(self,player):
	# imbue with spell ability
	return self.deity.rolld2() 

    def level5(self,player):
	# spell resistance
	return self.deity.rolld2() 

    def level6(self,player):
	# antimagic shield
	return self.deity.rolld2() 

    def level7(self,player):
	# spell turning
	return self.deity.rolld2() 

    def level8(self,player):
	# protection from spells
	return self.deity.rolld2() 

    def level9(self,player):
	# Mordenkainen's disjunction
	return self.deity.rolld2() 



