
# Copyright (C) Johan Ceuppens 2010 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *

class ClassSelector:
    "Class and Race Selector"
    def __init__(self, screen, font):
        self.screen = screen
        self.font = font
        self.background = pygame.image.load('./pics/blank.bmp').convert()
        self.klass = "Fighter"
        # fighters
        self.humanfighterimage = pygame.image.load('./pics/taskbar-PC.bmp').convert()
        self.gnollfighterimage = pygame.image.load('./pics/taskbar-PC-gnoll.bmp').convert()
        self.kattafighterimage = pygame.image.load('./pics/taskbar-PC-kattafighter.bmp').convert()
        self.elffighterimage = pygame.image.load('./pics/taskbar-PC-elffighter.bmp').convert()
        #### self.abeillefighterimage = pygame.image.load('./pics/taskbar-PC-abeillefighter.bmp').convert()
         
    def draw(self):
        ##self.screen.blit(self.background, (0, 300))
	
	pygame.draw.rect(self.screen, 0xbcbcbc, Rect(10,130,100,50)) 
	self.screen.blit(self.font.render("Fighter", 8, (255,255,255)), (10,130))
	pygame.draw.rect(self.screen, 0xdcdcdc, Rect(10,230,100,50)) 
	self.screen.blit(self.font.render("Magic User", 8, (255,255,255)), (10,230))
	pygame.draw.rect(self.screen, 0x8e8e8e, Rect(10,330,100,50)) 
	self.screen.blit(self.font.render("Rogue", 8, (255,255,255)), (10,330))
	self.screen.blit(self.font.render("Choose class", 8, (255,255,255)), (10,390))

    def select(self):
        while 1:
                self.draw()
                pygame.display.update()
                for event in pygame.event.get():
                    if event.type == QUIT:
                        return
                    if event.type == pygame.MOUSEBUTTONDOWN:
                        position = pygame.mouse.get_pos()
                        mousex = position[0]
                        mousey = position[1]
                        
                        if mousex > 0 and mousex < 100 and mousey > 80 and mousey < 230:
                            self.klass = "Fighter"
                            return
                        elif mousex > 0 and mousex < 100 and mousey > 180 and mousey < 330:
                            self.klass = "Magic User"
                            return
                        elif mousex > 0 and mousex < 100 and mousey > 280 and mousey < 430:
                            self.klass = "Rogue"
                            return

    def askclass(self):
        return self.klass
